﻿//////////////////////////////////////////////////
//               SettingForm.cs                 //
//         Part of RebornCo by kaihaider        //
//////////////////////////////////////////////////
using System;
using System.Linq;
using System.Windows.Forms;

namespace RebornCo.Settings
{
    public partial class SettingsForm : Form
    {
        public SettingsForm()
        {
            InitializeComponent();
        }

        private void SettingsForm_Load(object sender, EventArgs e)
        {
            propertyGrid1.SelectedObject = RebornCoRoutine.WindowSettings;
        }

        private void SettingsForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            RebornCoRoutine.WindowSettings.Save();

            RebornCoRoutine.WindowSettings.TankId = 0;

            if (RebornCoRoutine.WindowSettings.LastHotKeyChoice != RebornCoRoutine.WindowSettings.HotKeyChoice ||
                RebornCoRoutine.WindowSettings.LastModKeyChoice != RebornCoRoutine.WindowSettings.ModKeyChoice)
            {
                ff14bot.Managers.HotkeyManager.Unregister("RotationSwap");
                ff14bot.Managers.HotkeyManager.Register("RotationSwap", (Keys) System.Windows.Input.KeyInterop.VirtualKeyFromKey(RebornCoRoutine.WindowSettings.HotKeyChoice), 
                    (System.Windows.Input.ModifierKeys) RebornCoRoutine.WindowSettings.ModKeyChoice, 
                    hk => 
                    { 
                        Helpers.Spell.RotationSwap = !Helpers.Spell.RotationSwap; 
                        ff14bot.Helpers.Logging.Write(Helpers.Spell.RotationSwap ? "[RebornCo] Secondary Rotation Activated!" : "[RebornCo] Primary Rotation Resumed!"); 
                    });
                RebornCoRoutine.WindowSettings.LastHotKeyChoice = RebornCoRoutine.WindowSettings.HotKeyChoice;
                RebornCoRoutine.WindowSettings.LastModKeyChoice = RebornCoRoutine.WindowSettings.ModKeyChoice;
            }
            if (RebornCoRoutine.WindowSettings as WhiteMageSetting != null)
            {
                (RebornCoRoutine.WindowSettings as WhiteMageSetting).EsunaSpells = (RebornCoRoutine.WindowSettings as WhiteMageSetting).EsunaSpells.Replace(" ", string.Empty).ToLower();
                (RebornCoRoutine.WindowSettings as WhiteMageSetting).EsunaList = (RebornCoRoutine.WindowSettings as WhiteMageSetting).EsunaSpells.Split(',').ToList();
            }
            if (RebornCoRoutine.WindowSettings as MarauderSetting != null
                && (((MarauderSetting)RebornCoRoutine.WindowSettings).LastStormsPathHotKeyChoice != ((MarauderSetting)RebornCoRoutine.WindowSettings).StormsPathHotKeyChoice
                || ((MarauderSetting)RebornCoRoutine.WindowSettings).LastStormsPathModKeyChoice != ((MarauderSetting)RebornCoRoutine.WindowSettings).StormsPathModKeyChoice))
            {
                ff14bot.Managers.HotkeyManager.Unregister("StormsPath");
                ff14bot.Managers.HotkeyManager.Register("StormsPath",
                    (Keys) System.Windows.Input.KeyInterop.VirtualKeyFromKey(((MarauderSetting) RebornCoRoutine.WindowSettings).StormsPathHotKeyChoice),
                    (System.Windows.Input.ModifierKeys)
                        ((MarauderSetting) RebornCoRoutine.WindowSettings).StormsPathModKeyChoice,
                    hk =>
                    {
                        Helpers.Spell.StormsPath =
                            !Helpers.Spell.StormsPath;
                        ff14bot.Helpers.Logging.Write(Helpers.Spell.StormsPath
                            ? "[RebornCo] Storm's Path will be used!"
                            : "[RebornCo] Storm's Path combo halted!");
                    });
                 ((MarauderSetting) RebornCoRoutine.WindowSettings).LastStormsPathHotKeyChoice = ((MarauderSetting) RebornCoRoutine.WindowSettings).StormsPathHotKeyChoice;
                ((MarauderSetting) RebornCoRoutine.WindowSettings).LastStormsPathModKeyChoice = ((MarauderSetting) RebornCoRoutine.WindowSettings).StormsPathModKeyChoice;
            }

            RebornCoRoutine.Instance.UpdateContext();
        }
    }
}